# Class VulkanDependencyInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanDependencyInfo.Builder

Enclosing class:
  `VulkanDependencyInfo`

public static final class VulkanDependencyInfo.Builder extends Object
Builds instances of type `VulkanDependencyInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanDependencyInfo.Builder`
  `addAllBufferMemoryBarriers(Iterable<? extends VulkanBufferMemoryBarrier> elements)`
  Adds elements to `bufferMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addAllFlags(Iterable<VulkanDependencyFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanDependencyInfo.Builder`
  `addAllImageMemoryBarriers(Iterable<? extends VulkanImageMemoryBarrier> elements)`
  Adds elements to `imageMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addAllMemoryBarriers(Iterable<? extends VulkanMemoryBarrier> elements)`
  Adds elements to `memoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addBufferMemoryBarriers(VulkanBufferMemoryBarrier element)`
  Adds one element to `bufferMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addBufferMemoryBarriers(VulkanBufferMemoryBarrier... elements)`
  Adds elements to `bufferMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addFlags(VulkanDependencyFlag element)`
  Adds one element to `flags` set.
  `final VulkanDependencyInfo.Builder`
  `addFlags(VulkanDependencyFlag... elements)`
  Adds elements to `flags` set.
  `final VulkanDependencyInfo.Builder`
  `addImageMemoryBarriers(VulkanImageMemoryBarrier element)`
  Adds one element to `imageMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addImageMemoryBarriers(VulkanImageMemoryBarrier... elements)`
  Adds elements to `imageMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addMemoryBarriers(VulkanMemoryBarrier element)`
  Adds one element to `memoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `addMemoryBarriers(VulkanMemoryBarrier... elements)`
  Adds elements to `memoryBarriers` list.
  `VulkanDependencyInfo`
  `build()`
  Builds a new `VulkanDependencyInfo`.
  `final VulkanDependencyInfo.Builder`
  `from(VulkanDependencyInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanDependencyInfoType` instance.
  `final VulkanDependencyInfo.Builder`
  `setBufferMemoryBarriers(Iterable<? extends VulkanBufferMemoryBarrier> elements)`
  Sets or replaces all elements for `bufferMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `setFlags(Iterable<VulkanDependencyFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanDependencyInfo.Builder`
  `setImageMemoryBarriers(Iterable<? extends VulkanImageMemoryBarrier> elements)`
  Sets or replaces all elements for `imageMemoryBarriers` list.
  `final VulkanDependencyInfo.Builder`
  `setMemoryBarriers(Iterable<? extends VulkanMemoryBarrier> elements)`
  Sets or replaces all elements for `memoryBarriers` list.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanDependencyInfo.Builder from(VulkanDependencyInfoType instance)
    Fill a builder with attribute values from the provided `VulkanDependencyInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanDependencyInfo.Builder addFlags(VulkanDependencyFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanDependencyInfo.Builder addFlags(VulkanDependencyFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanDependencyInfo.Builder setFlags(Iterable<VulkanDependencyFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanDependencyInfo.Builder addAllFlags(Iterable<VulkanDependencyFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addMemoryBarriers

    public final VulkanDependencyInfo.Builder addMemoryBarriers(VulkanMemoryBarrier element)
    Adds one element to `memoryBarriers` list.
    Parameters:
      `element` - A memoryBarriers element
    Returns:
      `this` builder for use in a chained invocation

  - ### addMemoryBarriers

    public final VulkanDependencyInfo.Builder addMemoryBarriers(VulkanMemoryBarrier... elements)
    Adds elements to `memoryBarriers` list.
    Parameters:
      `elements` - An array of memoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setMemoryBarriers

    public final VulkanDependencyInfo.Builder setMemoryBarriers(Iterable<? extends VulkanMemoryBarrier> elements)
    Sets or replaces all elements for `memoryBarriers` list.
    Parameters:
      `elements` - An iterable of memoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllMemoryBarriers

    public final VulkanDependencyInfo.Builder addAllMemoryBarriers(Iterable<? extends VulkanMemoryBarrier> elements)
    Adds elements to `memoryBarriers` list.
    Parameters:
      `elements` - An iterable of memoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addBufferMemoryBarriers

    public final VulkanDependencyInfo.Builder addBufferMemoryBarriers(VulkanBufferMemoryBarrier element)
    Adds one element to `bufferMemoryBarriers` list.
    Parameters:
      `element` - A bufferMemoryBarriers element
    Returns:
      `this` builder for use in a chained invocation

  - ### addBufferMemoryBarriers

    public final VulkanDependencyInfo.Builder addBufferMemoryBarriers(VulkanBufferMemoryBarrier... elements)
    Adds elements to `bufferMemoryBarriers` list.
    Parameters:
      `elements` - An array of bufferMemoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setBufferMemoryBarriers

    public final VulkanDependencyInfo.Builder setBufferMemoryBarriers(Iterable<? extends VulkanBufferMemoryBarrier> elements)
    Sets or replaces all elements for `bufferMemoryBarriers` list.
    Parameters:
      `elements` - An iterable of bufferMemoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllBufferMemoryBarriers

    public final VulkanDependencyInfo.Builder addAllBufferMemoryBarriers(Iterable<? extends VulkanBufferMemoryBarrier> elements)
    Adds elements to `bufferMemoryBarriers` list.
    Parameters:
      `elements` - An iterable of bufferMemoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addImageMemoryBarriers

    public final VulkanDependencyInfo.Builder addImageMemoryBarriers(VulkanImageMemoryBarrier element)
    Adds one element to `imageMemoryBarriers` list.
    Parameters:
      `element` - A imageMemoryBarriers element
    Returns:
      `this` builder for use in a chained invocation

  - ### addImageMemoryBarriers

    public final VulkanDependencyInfo.Builder addImageMemoryBarriers(VulkanImageMemoryBarrier... elements)
    Adds elements to `imageMemoryBarriers` list.
    Parameters:
      `elements` - An array of imageMemoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setImageMemoryBarriers

    public final VulkanDependencyInfo.Builder setImageMemoryBarriers(Iterable<? extends VulkanImageMemoryBarrier> elements)
    Sets or replaces all elements for `imageMemoryBarriers` list.
    Parameters:
      `elements` - An iterable of imageMemoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllImageMemoryBarriers

    public final VulkanDependencyInfo.Builder addAllImageMemoryBarriers(Iterable<? extends VulkanImageMemoryBarrier> elements)
    Adds elements to `imageMemoryBarriers` list.
    Parameters:
      `elements` - An iterable of imageMemoryBarriers elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanDependencyInfo build()
    Builds a new `VulkanDependencyInfo`.
    Returns:
      An immutable instance of VulkanDependencyInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing